﻿(function () {
    'use strict';

    angular
        .module('app')
        .factory('LexBotService', LexBotService);

    function LexBotService(
        $http,
        $rootScope,
        $modal,
        toaster,
        AuthenticationService,
        AWS_REGION,
        LEX_BOT_NAME
        )
    {        
        var service = {};

        service.Initialise              = Initialise;
        service.SendText                = SendText;
        service.userId                  = 'idevelop-chatbot-' + Date.now();
        service.sessionAttributes       = null;
        service.initChatInteraction     = InitChatInteraction;
        service.lexRuntime              = null;

        AuthenticationService.RegisterAuthChangeListener("LexBotService", Initialise);

        Initialise();

        return service;

        function Initialise()
        {
            console.log("LexBotService::OnAuthChangeCallback");

            service.Singleton = service.lexruntime = new AWS.LexRuntimeV2({
                region: AWS_REGION
            });

            InitChatInteraction();
        }

        function InitChatInteraction()
        {
            service.sessionAttributes = {};
        }

        function SendText(
            text,
            callback
            )
        {
            var params = {
                botId: '0BTWXR7UVD',
                botAliasId: 'RNP6HPED0V',
                text: text,
                localeId: 'en_US',
                sessionId: service.userId
            };
            
            service.lexruntime.recognizeText(params, function(err, data) {
                if (err) 
                {
                    console.log(err, err.stack);
                    toaster.error({title: "Chat Error", body:"An error has occurred while processing your chat!", timeout:5000});
                }
                else
                {
                    // capture the sessionAttributes for the next cycle
                    service.sessionAttributes = data.sessionAttributes;
                }
                
                if ( callback )
                {
                    $rootScope.$apply(function()
                    {
                        callback(data);
                    });                    
                }
            });
            
        }

        
    };

})();
