﻿var applianceManagerApp = null;

(function () {
    'use strict';

    applianceManagerApp = angular
        .module('app', ['ngRoute', 'ngCookies', 'ngAnimate', 'toaster', 'ui.bootstrap', 'ui.bootstrap-slider', 'btorfs.multiselect', 'irontec.simpleChat'])
        .config(config)
        .run(onPageLoad)

    function config($routeProvider, $locationProvider) {
        $routeProvider
        .when('/', {
            controller: 'HomeController',
            templateUrl: 'home/home.view.html',
            controllerAs: 'vm'
        })
        .when('', {
            controller: 'HomeController',
            templateUrl: 'home/home.view.html',
            controllerAs: 'vm'
        })

            .otherwise({ redirectTo: '/' }); 
    }

    function onPageLoad(
        $rootScope,
        $location,
        $cookieStore,
        $http,
        AuthenticationService,
        COGNITO_USER_POOL,
        COGNITO_USER_POOL_CLIENT_ID,
        AWS_REGION
        )
      {
        console.log("onPageLoad()");

        AWS.config.region = AWS_REGION;

        //
        // keep user logged in after page refresh
        //
        if (AuthenticationService.CognitoSignInData && AuthenticationService.CognitoSignInData.currentUser)
        {
            AuthenticationService.GetUserSession(
                AuthenticationService.CognitoSignInData.currentUser,
                function(response)
                {
                    if (!response.succeeded)
                    {
                        console.log("Failed to get user token () -> " + response.message);
                        $location.path('/');
                    }
                }
            );
        }
        else
        {
            // otherwise, use the unauth Cognito role
            AuthenticationService.UnauthUserAccess();
        }

        $rootScope.$on('$locationChangeStart', function (event, next, current)
        {
        });
    }

})();
